// HashDlg.h : header file
//

#if !defined(AFX_HashDLG_H__D13A50DD_3B5B_4039_8DDB_7FDA3D509B9E__INCLUDED_)
#define AFX_HashDLG_H__D13A50DD_3B5B_4039_8DDB_7FDA3D509B9E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CHashDlg dialog

class CHashDlg : public CDialog
{
// Construction
public:
	CHashDlg(CWnd* pParent = NULL);	// standard constructor
	~CHashDlg()
	{
		if (NULL != m_pHashCalc)
			delete m_pHashCalc;
	}

// Dialog Data
	//{{AFX_DATA(CHashDlg)
	enum { IDD = IDD_HASH_DIALOG };
	CProgressCtrl	m_Pos;
	CComboBox	m_cbxAlgorithm;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHashDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CHashDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnRadioString();
	afx_msg void OnRadioFile();
	afx_msg void OnSelchangeComboAlgorithm();
	afx_msg void OnCheckHmac();
	afx_msg void OnBtnBrowse();
	afx_msg void OnBtnCopy();
	afx_msg void OnBtnCalculate();
	afx_msg void OnCheckUppdrcase();
	afx_msg void OnBtnAbout();
	virtual void OnOK();
	afx_msg void OnChangeEditData();
	afx_msg void OnChangeEditKey();
	afx_msg void OnDropFiles(HDROP hDropInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

	/*TRUE for String data type, Otherwise FALSE*/
	void AdjustDataSourceEditWnd(BOOL bFlag);

	/* Get ANSI text string from edit control */
	string GetEditTextA(HWND hwnd);

	/* the file starting thread */
	DWORD __stdcall ThreadProc(LPVOID lpParam);

	/* the progress of the specify file */
	void Progress(int n);

	/* show details error information */
	void ShowErrorInfo(DWORD dwCode);

	/* enable or disable all control of window */
	void Enable(BOOL bEnable);

private:

	FileDlg m_FileDlg;
	BOOL m_bIsStarting;
	Thunk m_pThreadProc;
	HashCalc* m_pHashCalc;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HashDLG_H__D13A50DD_3B5B_4039_8DDB_7FDA3D509B9E__INCLUDED_)
