
/*++

Autor: Zhang Luduo (³)
Email: Support@ZhangLuduo.com 
MSN  : ZhangLuduo@msn.com
WEB  : http://www.ZhangLuduo.com/

Copyright 2006-2009 Zhang Luduo. All rights reserved.

--*/

/*++

ļд, ڴӳļԭʵ, Զ
ļжд. ڴӳļص, 
Ҫ׷дļ

2009-04-21
һwindows98µصbug, һ
Աn_pbRWm_pbFileĸֵ

--*/

#ifndef _FILE_H
#define _FILE_H

#ifndef _INT_WINDOWS
#	include <windows.h>
#endif

#ifndef _INC_TCHAR
#	include <tchar.h>
#endif

class File
{
public:

	//
	// construction and destruction
	//

	File();
	virtual ~File();

	//
	// open and close
	//

	BOOL Open(TCHAR* FileName, DWORD dwAccess = GENERIC_READ/* | GENERIC_WRITE*/,
					DWORD dwShareMode = FILE_SHARE_READ);
	BOOL Create(TCHAR* FileName, DWORD64 FileSize = 0, 
					DWORD dwCreationDisposition = CREATE_NEW/*CREATE_ALWAYS*/,
					DWORD dwShareMode = FILE_SHARE_READ);
	BOOL Close();

	//
	// position and size
	//

	DWORD64 GetFileSize();
	DWORD64 GetPosition();
	DWORD64 SetPosition(DWORD64 nPos);

	//
	// read and write
	//

	DWORD Read(void *Buffer, DWORD BufferLen);
	DWORD Write(void *pData, DWORD DataLen);
	DWORD AppendWrite(void *pData, DWORD DataLen);

	//
	// Error information
	//

	DWORD GetErrorCode();

private:

	//
	// the private functions
	//

	DWORD MapView(DWORD ViewSize);
	BOOL AppendSize(DWORD dwAppendSize);

protected:

	//
	// data members
	//

	HANDLE  m_hFile;
	HANDLE  m_hMapping;
	PBYTE   m_pbFile, n_pbRW;

	DWORD64 m_nSize;
	DWORD64 m_nPosition;

	DWORD   m_nSysGranularity;
	DWORD   m_dwAccess;
	DWORD   m_dwErrorCode;
};

#endif