
/*++

Autor: Zhang Luduo (³)
Email: Support@ZhangLuduo.com 
MSN  : ZhangLuduo@msn.com
WEB  : http://www.ZhangLuduo.com/

Copyright 2006-2009 Zhang Luduo. All rights reserved.

--*/

/*
: 

Thunk : һλӦֽڱһڴṹ, 
Ȼָǿתɺ. ִ.

ݴڽC﷽ĻصתΪthisָC++
Ա.

Windowsϵͳ, ԽһЩϵͳغװC++
Ա, 

// ʱص
VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg, 
UINT_PTR idEvent, DWORD dwTime);

// ̻߳ص
DWORD WINAPI ThreadProc(LPVOID lpParameter);

// ڹ̻ص
LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, 
WPARAM wParam, LPARAM lParam);

2008-10-22Windows XP SP2, Windows server 2003
¿DEPܺбBUG

*/

#ifndef _THUNK_H
#define _THUNK_H

//
// type redefinition
//

typedef unsigned char  u1byte; // an 8 bit unsigned character type
typedef unsigned short u2byte; // a 16 bit unsigned integer type
typedef unsigned long  u4byte; // a 32 bit unsigned integer type
typedef char           s1byte; // an 8 bit signed character type
typedef short          s2byte; // a 16 bit signed integer type
typedef long           s4byte; // a 32 bit signed integer type
typedef void*          pvoid;  // a 32 bit undefined type pointer

class Thunk
{
public:

	Thunk();
	virtual ~Thunk();

	pvoid Thiscall(pvoid pThis, u4byte MemberFxnAddr);
	pvoid Stdcall (pvoid pThis, u4byte MemberFxnAddr);

	template <typename T> 
	static u4byte GetMemberFxnAddr(T MemberFxnName)
	{
		union
		{
			T From; 
			u4byte To;
		}	union_cast;
		union_cast.From = MemberFxnName;
		return union_cast.To;
	}

private:

	#pragma pack (push, 1)
	
	typedef struct _BYTECODE_THISCALL
	{
		u1byte Mov;     // 0xB9
		u4byte This;    // this pointer
		u1byte Jmp;     // 0xE9
		u4byte Adrr;    // relative jmp
	}	BYTECODE_THISCALL, *PBYTECODE_THISCALL;

	typedef struct _BYTECODE_STDCALL
	{
		u1byte Push[3]; // push dword ptr[esp] ;
		u4byte Move;    // mov dword ptr [esp + 4], ?? ?? ?? ?? ;
		u4byte This;    // this pointer
		u1byte Jmp;     // 0xE9
		u4byte Adrr;    // relative jmp
	}	BYTECODE_STDCALL, *PBYTECODE_STDCALL;

	#pragma pack (pop)

	// u1byte m_BytecodeThiscall[10];
	// u1byte m_BytecodeStdcall [16];

	BYTECODE_THISCALL m_BytecodeThiscall;
	BYTECODE_STDCALL  m_BytecodeStdcall;

	Thunk* m_pThis;
};

#endif // #define _THUNK_H
