
/*

Autor: Zhang Luduo (³)
Email: zhangluduo@163.com
MSN  : zhangluduo@msn.com

Copyright 2006-2009 Zhang Luduo. 
All Rights Reserved.

*/

/*
:

ͨöԻ֮[ļ], [ļ], [Ŀ¼]

Modified date: 2009-06-10
Modified date: 2009-06-08
*/

#ifndef _FILEDLG_H
#define _FILEDLG_H

#ifndef _INC_WINDOWS
	#include <windows.h>
#endif

#ifndef _SHLOBJ_H_
	#include <Shlobj.h>
#endif

#ifndef _SHLOBJ_H_
	#include <Shlobj.h>
#endif

#ifndef _INC_TCHAR
	#include <tchar.h>
#endif

#include "tstring.h"
#include "Thunk.h"
//#pragma comment(lib, "Thunk.lib")

#pragma warning(disable : 4786 4018 4996)
#include <vector>
using namespace std;

class FileDlg
{
public:

	FileDlg();

	virtual ~FileDlg();

	vector<tstring> GetOpenFileName(HWND hWnd, BOOL bMultiSelect = FALSE, 
					TCHAR* strFilter = NULL, tstring strInitName = _T(""), 
					tstring strInitDir = _T(""));

	tstring GetSaveFileName(HWND hWnd, BOOL bAutoAddExtName = TRUE, 
					TCHAR* strFilter = NULL, tstring strInitName = _T(""), 
					tstring strInitDir = _T(""));

	tstring GetBrowseForFolder(HWND hWnd, tstring strInitDir = _T(""));

	void SetBufferSize(DWORD dwBufferSize);

	DWORD GetBufferSize();

	void SetInitDir(tstring strDir);

protected:

	OPENFILENAME m_OFNOpen;
	OPENFILENAME m_OFNSave;
	BROWSEINFO m_BIFBrowse;

protected:

	virtual UINT_PTR OpenProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	virtual UINT_PTR SaveProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	virtual int BrowseProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData);

private:

	Thunk m_lpOpenProc;
	Thunk m_lpSaveProc;
	Thunk m_lpBrowseProc;

	tstring m_InitName;
	tstring m_InitDir;

	TCHAR* m_NameBuf;
	DWORD m_dwBufferSize;
	BOOL m_bBrowseInit;
};

#endif
